
#include "lcd_dip122.h"
#include "io.h"
#include "printf_P.h"

static bitmap PROGMEM example = {
  60, 14,
  {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x0c, 0x00, 0x00, 0x00, 0x00, 0x00,
   0x00, 0x00, 0x0c, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x06, 0x00,
   0x78, 0x8c, 0x79, 0xd8, 0x0e, 0x3b, 0x86, 0x07, 0xcc, 0xcc, 0xcc, 0xb8,
   0x1b, 0x67, 0xc6, 0x0c, 0xc6, 0x68, 0xc0, 0x98, 0x99, 0x63, 0x63, 0x0c,
   0x7e, 0x38, 0x7c, 0xcc, 0x8c, 0x61, 0xe3, 0x07, 0x03, 0x38, 0x66, 0xcc,
   0x8c, 0x31, 0x33, 0x00, 0x03, 0x2c, 0x63, 0xcc, 0x8c, 0x31, 0x33, 0x00,
   0x33, 0x66, 0x33, 0x66, 0xc6, 0x9b, 0x31, 0x03, 0x1e, 0x63, 0x6e, 0x66,
   0xc6, 0x8e, 0xe1, 0x01, 0x00, 0x00, 0x00, 0x00, 0xc0, 0x00, 0x00, 0x00,
   0x00, 0x00, 0x00, 0x00, 0x60, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
   0x60, 0x00, 0x00, 0x00}};

static void delay (void);

int main(void)
{
  int8_t count1 = 0;
  uint16_t count2 = 0;

  init_lcd ();
  display_on();
  lcd_cleardisplay();
  init_font7x13bold();
  lcd_drawing_mode = lcd_replace;

  printf ("printf");
  /* of course text and graphics can be displayed at the same time */
  lcd_drawbitmap_P (0, 14,(bitmap PROGMEM *)&example);

  while (1) {
    lcd_cursor_x = 88; /* set cursor position */
    lcd_cursor_y = 31;
    printf ("%04i", count1); /* signed integer, field width 4, pad with 0 */
    lcd_cursor_x = 74;
    lcd_cursor_y = 15;
    printf ("%#06x", count2);
    delay ();
    count1++;
    count2++;
  }
}

static void delay ()
{
  uint8_t i, j;

  for (i=0; i<255; i++)
    for (j=0; j<255; j++)
	asm volatile ("nop" ::);
}
