/* Low level procedure for drawing 1bpp xbm bitmaps               */
/* pixeldata in RAM                                               */
/*                                                                */
/* Copyright (C) 2001  Michael Schnzler                          */
/*                                                                */
/* TODO                                                           */
/*   error checking                                               */
/*   merge with lcd_drawpixeldata_P                               */

#include "lcd_dip122.h"

static uint8_t get_bitmap_pixel (uint8_t x, uint8_t y, uint8_t width,
				 uint8_t *pixel_data);

void lcd_drawpixeldata (uint8_t x, uint8_t y,
			uint8_t dx, uint8_t dy,
			uint8_t *pixel_data,
			uint8_t (*operation)(uint8_t, uint8_t, uint8_t))
{
  uint8_t i, j;
  uint8_t page;
  uint8_t s1;
  uint8_t mask1, mask2;

  mask1 = 0xff << (MAX_Y-y)%8;
  mask2 = ~(0xff << (MAX_Y-y+dy)%8);

  for (i=0; i<dx; i++) {
    page = (MAX_Y-y)/8;
    s1 = 0;
    
    for (j=0; j<dy; j++) { 
      
      if (get_bitmap_pixel (i, j, dx, pixel_data))
	s1 |= (1 << (MAX_Y-y+j)%8);
      
      if ((MAX_Y-y+j+1)%8 == 0) {   /* page boundary, j+1 wre neue Page */
	 /* alte Page schreiben */
	write_display_data (s1, x+i, page, operation, mask1);
	mask1 = 0xff;
	s1 = 0;
 	page++;
      }
    }
    if ((MAX_Y-y+dy)%8 != 0)     /* Ende nicht genau auf Page Grenze */
      write_display_data (s1, x+i, page, operation, mask2);
  }
}


/* returns the bit at Bitmap Coordinate (x,y) */
/* (0,0) at upper left corner                 */ 
static uint8_t get_bitmap_pixel (uint8_t x, uint8_t y, uint8_t width,
				 uint8_t *pixel_data)
{
  uint16_t byte_offset;
  uint8_t bitpos;

  byte_offset = y*((width+7)/8) + x/8;

  bitpos = x%8;

  return (*(pixel_data + byte_offset) & (1 << bitpos));
}
