#include "lcd_dip122.h"

static void lcd_advance_cursor_pos (char c);

font lcd_current_font;

void print_string (uint8_t x, uint8_t y, char *str)
{
  uint8_t i = 0;

/*   if(strlen(str) > 255) */
/*     return; */

  while (*(str+i) != '\0') {
    lcd_printchar (x, y, *(str+i));
    i++;
    x=x+lcd_current_font.width;
  }
}

void lcd_printchar (uint8_t x, uint8_t y, char c)
{
  uint8_t width = lcd_current_font.width;
  uint8_t height =  lcd_current_font.height;
  uint8_t PROGMEM *glyph = 
    (uint8_t PROGMEM *)(lcd_current_font.glyphs + height*c);

  lcd_drawpixeldata_P (x, y, width, height,
		       glyph,
		       lcd_drawing_mode);
}

void lcd_write_char (char c)
{
  lcd_printchar (lcd_cursor_x, lcd_cursor_y, c);
  lcd_advance_cursor_pos (c);
}


void lcd_advance_cursor_pos (char c)
{
  lcd_cursor_x += lcd_current_font.width;
}
